#include "DataCalculations.h"


void DataCalculations::SMA(size_t period)
{
	double runningSum = 0;
	for (size_t i = 0; i < close.size(); i++)
	{
		runningSum += close.at(i);
		if (i >= period)
			runningSum -= close.at(i - period);
		if (i >= (period - 1))
			sma.push_back(runningSum / period);
	}
}

void DataCalculations::ATR(double period)
{
	for (size_t i = high.size() - 1 ; i-- > 0;)
	{
		tr1 = abs(high.at(i) - low.at(i));
		tr2 = abs(low.at(i) - close.at(i + 1));
		tr3 = abs(high.at(i) - close.at(i + 1));

		//finding the true range
		if (tr1 >= tr2)
		{
			if (tr1 >= tr3)
				trueRange.push_back(tr1);
			else
				trueRange.push_back(tr3);	
		}
		else
		{
			if (tr2 > tr3)
				trueRange.push_back(tr2);
			else
				trueRange.push_back(tr3);
		}			
	}

	//finding the Average True Range over x periods
	double runningSum = 0;

	for (size_t i = 0; i < trueRange.size(); i++)
	{
		runningSum += trueRange.at(i);
		if (i >= period)
			runningSum -=trueRange.at(size_t(i - period));
		if (i >= size_t(period - 1))
			atr.push_back(runningSum / period);	
	}
	cout << atr.size() << endl;

}

void DataCalculations::relativeStrengthIndex(double period)
{
	for (size_t i = high.size() - 1; i-- > 0;)
	{
		if (open.at(i) > close.at(i))
		{
			downChange.push_back(open.at(i) - close.at(i));
			upChange.push_back(0);
		}
		else if (close.at(i) > open.at(i))
		{
			upChange.push_back(close.at(i) - open.at(i));
			downChange.push_back(0);
		}
		else if (close.at(i) == open.at(i))
		{
			upChange.push_back(0);
			downChange.push_back(0);
		}
	}
 //finding the averages
	double runningSum = 0;
	double runningSum1 = 0;
	double today = 0;
	for (size_t i = 0; i < upChange.size(); i++)
	{
		//upward change in prices
		runningSum += upChange.at(i);
		if (i >= period)
		{
			runningSum -= upChange.at(size_t(i - period));
			runningSum += upChangeAvg.at(size_t(today-1)); //today - 1 = yesterday
			if (today > 1)
				runningSum -= upChangeAvg.at(size_t(today - 2));//today - 2 = day before yesterday
		}
		if (i >= (period - 1))
		{
			upChangeAvg.push_back(runningSum / period);
		}

		//downward change in prices
		runningSum1 += downChange.at(i);
		if (i >= period)
		{
			runningSum1 -= downChange.at(size_t(i - period));
			runningSum1 += downChangeAvg.at(size_t(today - 1)); //today - 1 = yesterday
			if (today > 1)
				runningSum1 -= downChangeAvg.at(size_t(today - 2));//today - 2 = day before yesterday
		}
		if (i >= (period - 1))
		{
			downChangeAvg.push_back(runningSum1 / period);
			today++;
		}

	}
	//finding the relative strength index
	for (size_t i = 0; i < upChangeAvg.size(); i++)
	{
		rsi.push_back(100 - 100 /(1+ (upChangeAvg.at(i) / downChangeAvg.at(i))));
	}
}





